local mod = ...

--[[

    Changes various balancing factors

    Dev to-do list --------------------------------------------------------------------
    

]]



-- Reduce territory taxes
mod:override({
	Id = "DEFAULT_BALANCING",
	TerritoryRoyalTaxesList = {
		{ { Resource = "GOLD", Quantity = 0 } },
		{ { Resource = "GOLD", Quantity = 5 } },
		{ { Resource = "GOLD", Quantity = 10 } },
		{ { Resource = "GOLD", Quantity = 15 } },
		{ { Resource = "GOLD", Quantity = 20 } },
		{ { Resource = "GOLD", Quantity = 25 } },
		{ { Resource = "GOLD", Quantity = 25 } },
		{ { Resource = "GOLD", Quantity = 30 } },
		{ { Resource = "GOLD", Quantity = 30 } },
		{ { Resource = "GOLD", Quantity = 35 } }
	}
})



-- Purchase prices for goods and services
mod:override({ Id = "FAITH", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 1 } })
mod:override({ Id = "BERRIES", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 1 } })
mod:override({ Id = "BV1_EGG", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "GRAPES", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "MILK", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "WOOD", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "RESOURCE_VEGETABLE", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_CANDLE", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_FRUIT", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "BREAD", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "COAL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "FISH", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "HERBS", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "LEATHER", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_POULTRY", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_CIDER", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "BEER", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })
mod:override({ Id = "CHEESE", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })
mod:override({ Id = "HONEY", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })
-- mod:override({ Id = "PV3_PASTRY", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })
-- mod:override({ Id = "PV4_PASTRY", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })
mod:override({ Id = "BV1_PASTRY", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })
-- mod:override({ Id = "MEAT_RESOURCE", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 8 } })
mod:override({ Id = "BV1_MEAT", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 8 } })
mod:override({ Id = "BOAR", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 12 } })
mod:override({ Id = "CLOTHES", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 12 } })
mod:override({ Id = "WINE", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 12 } })
mod:override({ Id = "RESOURCE_FURNITURE", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 12 } })
mod:override({ Id = "GEMS", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 100 } })
mod:override({ Id = "JEWELRY", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 150 } })
mod:override({ Id = "MEAL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 10 } }) -- game seems to double this price, so real price is 20

mod:override({ Id = "RESOURCE_WOOD_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "RESOURCE_MILK_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "RESOURCE_POULTRY_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_EGG_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 2 } })
mod:override({ Id = "RESOURCE_VEGETABLE_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_FRUIT_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 4 } })
mod:override({ Id = "RESOURCE_BERRIES_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 1 } })
mod:override({ Id = "RESOURCE_HONEY_SELL", VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 } })



-- Tax Collectors: Double employment, add more taxable buildings -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_FUNCTION_TAX_OFFICE",
    WorkerCapacity = 2,
    TaxableBuildingList = {  
        "BUILDING_BAKERY",
        "BUILDING_BLACKSMITH",
        "BUILDING_BREWERY",
        "BUILDING_CHEESE_MAKER",
        "BUILDING_COOPERAGE",
        "BUILDING_JEWELER_WORKSHOP",
        "BUILDING_STONEMASON_HUT",
        "BUILDING_TAILOR_WORKSHOP",
        "BUILDING_WEAPONSMITH",
        "BUILDING_WEAVER_HUT",
        "BUILDING_WINDMILL",
        "MONUMENT_TAVERN",
        "MONUMENT_MARKET"
    }
})



-- Increase warehouse capacity -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FUNCTION_WAREHOUSE",
	SocketCapacity = 200,
	WorkerCapacity = 4
})



-- Increase granary capacity -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FUNCTION_GRANARY",
	SocketCapacity = 200,
	WorkerCapacity = 4
})



-- Slow down the shepherd -------------------------------------------------------------------------------------
mod:override({
	Id = "SHEPHERD",
	ProductionDelay = 45
})



-- Slow down the fisherman -------------------------------------------------------------------------------------
mod:override({
	Id = "FISHERMAN",
	ProductionDelay = 60
})



-- Slow down the forager -------------------------------------------------------------------------------------
mod:override({
	Id = "GATHERER",
	ProductionDelay = 40
})



-- Increase Beer production -------------------------------------------------------------------------------------
-- Didn't alter the production delay as there is a long animation involved
-- Instead I double production from every unit of hops
mod:override({
    Id = "BUILDING_FUNCTION_BREWERY",
    ResourceProduced = {{ Resource = "BEER", Quantity = 2 }}
})



-- Implement all changes to main Balancing asset -------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    BuildingCostOverrideList = {
        Action = "APPEND", "JACKIE_BUILDING_PART_COST_LIST_OVERRIDE" -- puts in the list of custom prices, resources, upkeep, etc
    }, 
--    InitialFamilyCount = 14,  -- makes more people available at the beginning of the game
    VillagerCountPerImmigrationWave = {1, 3}, -- increases number of people possible in each wave to between 1 and 6

})



-- Change the native buildings controlled by Building Part Cost List, by creating a cost list override and appending to the default balancing ID -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_PART_COST_LIST",
    Id = "JACKIE_BUILDING_PART_COST_LIST_OVERRIDE",
    BuildingPartCostList = {

        -- Lumber camp
        {
            BuildingPart = "BUILDING_PART_WOODCUTTER_CAMP",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 1 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        }, 

        -- Stonecutter camp
        {
            BuildingPart = "BUILDING_PART_STONECUTTER_CAMP",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 1 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        }, 

        -- Well
        {
            BuildingPart = "BUILDING_PART_WELL",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 1 }, 
                    { Resource = "STONE", Quantity = 4 }
                }
            }
        }, 

        -- Gathering hut
        {
            BuildingPart = "BUILDING_PART_GATHERING_CAMP",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 5 }
                }
            }
        }, 

        -- Sawmill
        {
            BuildingPart = "BUILDING_PART_SAWMILL",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 20 }, 
                    { Resource = "STONE", Quantity = 10 }
                }
            }
        }, 

        -- Stonemason hut
        {
            BuildingPart = "BUILDING_PART_STONEMASON",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "WOOLEN_CLOTH", Quantity = 5 }
                }
            }
        }, 

        -- Granary
        {
            BuildingPart = "BUILDING_PART_GRANARY",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 50 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 15 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 20 }, 
                    { Resource = "STONE", Quantity = 10 }
                }
            }
        }, 

        -- Warehouse
        {
            BuildingPart = "BUILDING_PART_WAREHOUSE",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 50 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 15 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 20 }, 
                    { Resource = "STONE", Quantity = 10 }
                }
            }
        }, 

        -- Foresters camp
        {
            BuildingPart = "BUILDING_PART_FORESTER",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 2 }
                }
            }
        }, 

        -- Dairy farm
        {
            BuildingPart = "BUILDING_PART_DAIRY_FARM",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 20 }, 
                    { Resource = "STONE", Quantity = 10 }
                }
            }
        },


        -- Blacksmith
        {
            BuildingPart = "BUILDING_PART_BLACKSMITH",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 25 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "PLANK", Quantity = 20 }, 
                    { Resource = "TOOL", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 20 }, 
                    { Resource = "POLISHED_STONE", Quantity = 5 }
                }
            }
        }, 

        -- Iron Smelter
        {
            BuildingPart = "BUILDING_PART_IRON_SMELTER",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 25 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "PLANK", Quantity = 20 }, 
                    { Resource = "TOOL", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 20 }
                }
            }
        },

        -- Coal hut
        {
            BuildingPart = "BUILDING_PART_COAL_HUT",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 15 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 5 }, 
                    { Resource = "PLANK", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 10 }
                }
            }
        },


        -- Sheep farm
        {
            BuildingPart = "BUILDING_PART_SHEEP_FARM",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 15 }, 
                    { Resource = "STONE", Quantity = 2 }
                }
            }
        },


        -- Wheat farm
        {
            BuildingPart = "BUILDING_PART_WHEAT_FARM",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 15 }, 
                    { Resource = "PLANK", Quantity = 5 }, 
                    { Resource = "STONE", Quantity = 2 }
                }
            }
        },


        -- Bakery
        {
            BuildingPart = "BUILDING_PART_BAKERY",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 25 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 5 }
                },
                RessourcesNeeded = {
                    { Resource = "STONE", Quantity = 10 }, 
                    { Resource = "PLANK", Quantity = 20 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        },

        -- Windmill
        {
            BuildingPart = "BUILDING_PART_WINDMILL",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 35 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                RessourcesNeeded = {
                    { Resource = "PLANK", Quantity = 20 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 15 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        },

        -- Weaver
        {
            BuildingPart = "BUILDING_PART_WEAVER_HUT",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 25 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                RessourcesNeeded = {
                    { Resource = "PLANK", Quantity = 15 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 5 }
                }
            }
        },

        -- Tailor
        {
            BuildingPart = "BUILDING_PART_TAILOR_WORKSHOP",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 25 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                RessourcesNeeded = {
                    { Resource = "PLANK", Quantity = 15 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "STONE", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 5 }
                }
            }
        }, 

        -- Fisher
        {
            BuildingPart = "BUILDING_PART_FISHING_HUT",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 1 }
                }
            }
        },

        -- Hunter's Hut
        {
            BuildingPart = "BUILDING_PART_HUNTERS_HUT",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 1 }
                },
                RessourcesNeeded = {
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 1 }
                }
            }
        },

        -- Cheese maker
        {
            BuildingPart = "BUILDING_PART_CHEESE_MAKER",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 35 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 15 }
                },
                RessourcesNeeded = {
                    { Resource = "STONE", Quantity = 15 }, 
                    { Resource = "PLANK", Quantity = 20 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        },

        -- Brewery
        {
            BuildingPart = "BUILDING_PART_BREWERY",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 35 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 15 }
                },
                RessourcesNeeded = {
                    { Resource = "STONE", Quantity = 15 }, 
                    { Resource = "PLANK", Quantity = 20 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        },

        -- Hop farm
        {
            BuildingPart = "BUILDING_PART_HOP_FARM",
            BuildingPartCost = {
                BuildRightTaxes = {
                    { Resource = "GOLD", Quantity = 15 }
                },
                UpkeepCost = {
                    { Resource = "GOLD", Quantity = 10 }
                },
                RessourcesNeeded = {
                    { Resource = "STONE", Quantity = 15 }, 
                    { Resource = "PLANK", Quantity = 10 }, 
                    { Resource = "WOOD", Quantity = 10 }, 
                    { Resource = "TOOL", Quantity = 2 }
                }
            }
        },

		-- Cooperage
		{
			BuildingPart = "BUILDING_PART_COOPERAGE",
			BuildingPartCost = {
				BuildRightTaxes = {
					{ Resource = "GOLD", Quantity = 25 }
				},
				UpkeepCost = {
					{ Resource = "GOLD", Quantity = 20 }
				},
				RessourcesNeeded = {
					{ Resource = "STONE", Quantity = 8 }, 
					{ Resource = "PLANK", Quantity = 10 }, 
					{ Resource = "WOOD", Quantity = 10 }, 
					{ Resource = "TOOL", Quantity = 2 },
				}
			}
		},

		-- Vineyard
		{
			BuildingPart = "BUILDING_PART_VINEYARD",
			BuildingPartCost = {
				BuildRightTaxes = {
					{ Resource = "GOLD", Quantity = 20 }
				},
				UpkeepCost = {
					{ Resource = "GOLD", Quantity = 15 }
				},
				RessourcesNeeded = {
					{ Resource = "STONE", Quantity = 16 }, 
					{ Resource = "PLANK", Quantity = 8 }, 
					{ Resource = "WOOD", Quantity = 8 }, 
				}
			}
		},

		-- Weaponsmith
		{
			BuildingPart = "BUILDING_PART_WEAPONSMITH",
			BuildingPartCost = {
				BuildRightTaxes = {
					{ Resource = "GOLD", Quantity = 25 }
				},
				UpkeepCost = {
					{ Resource = "GOLD", Quantity = 15 }
				},
				RessourcesNeeded = {
					{ Resource = "STONE", Quantity = 8 }, 
					{ Resource = "PLANK", Quantity = 10 }, 
					{ Resource = "WOOD", Quantity = 10 }, 
					{ Resource = "TOOL", Quantity = 2 },
				}
			}
		},


    }
})